searchNodes=[{"doc":"Hierarchical deterministic wallet. It has the following features: Generate mnemonic Generate seed from mnemonic Generate master keys from seed Derive private and public keys from the master key Various utility functions to work with derivation path, keys, crypto addresses","ref":"Cryptopunk.html","title":"Cryptopunk","type":"module"},{"doc":"Generate mnenmonic with the given number of words (24 by default). See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki Examples: iex&gt; mnemonic1 = Cryptopunk . create_mnemonic ( ) iex&gt; mnemonic2 = Cryptopunk . create_mnemonic ( ) iex&gt; mnemonic1 |&gt; String . split ( &quot; &quot; ) |&gt; Enum . count ( ) 24 iex&gt; mnemonic1 != mnemonic2 true","ref":"Cryptopunk.html#create_mnemonic/1","title":"Cryptopunk.create_mnemonic/1","type":"function"},{"doc":"Generate mnemonic from entropy. Examples: iex&gt; bytes = &lt;&lt; 6 , 197 , 169 , 93 , 98 , 210 , 82 , 216 , 148 , 177 , 1 , 251 , 142 , 15 , 154 , 85 , 140 , 0 , 13 , 202 , 234 , 160 , 129 , 218 &gt;&gt; iex&gt; Cryptopunk . create_mnemonic_from_entropy ( bytes ) &quot;almost coil firm shield cement hobby fan cage wine idea track prison scale alone close favorite limb still&quot;","ref":"Cryptopunk.html#create_mnemonic_from_entropy/1","title":"Cryptopunk.create_mnemonic_from_entropy/1","type":"function"},{"doc":"Generate seed from mnemonic. See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki#from-mnemonic-to-seed Examples: iex&gt; mnemonic = &quot;almost coil firm shield cement hobby fan cage wine idea track prison scale alone close favorite limb still&quot; iex&gt; Cryptopunk . create_seed ( mnemonic ) &lt;&lt; 180 , 208 , 65 , 58 , 208 , 96 , 16 , 14 , 214 , 63 , 190 , 54 , 77 , 169 , 17 , 207 , 191 , 239 , 227 , 252 , 200 , 195 , 135 , 251 , 68 , 70 , 169 , 124 , 100 , 147 , 143 , 61 , 26 , 196 , 128 , 18 , 245 , 89 , 94 , 32 , 11 , 35 , 71 , 132 , 156 , 123 , 140 , 123 , 114 , 55 , 72 , 40 , 57 , 245 , 153 , 249 , 124 , 98 , 130 , 203 , 108 , 168 , 109 , 144 &gt;&gt;","ref":"Cryptopunk.html#create_seed/2","title":"Cryptopunk.create_seed/2","type":"function"},{"doc":"Derives key https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; { :ok , path } = Cryptopunk . parse_path ( &quot;m / 44&#39; / 0&#39; / 0&#39; / 0 / 0&quot; ) iex&gt; seed |&gt; Cryptopunk . master_key_from_seed ( ) |&gt; Cryptopunk . derive_key ( path ) % Cryptopunk.Key { chain_code : &lt;&lt; 166 , 125 , 2 , 213 , 77 , 88 , 124 , 145 , 241 , 251 , 83 , 163 , 21 , 11 , 20 , 34 , 158 , 157 , 179 , 147 , 162 , 212 , 148 , 89 , 28 , 92 , 68 , 126 , 215 , 79 , 147 , 159 &gt;&gt; , depth : 5 , index : 0 , key : &lt;&lt; 214 , 231 , 94 , 203 , 167 , 219 , 125 , 43 , 251 , 91 , 147 , 51 , 32 , 146 , 186 , 215 , 58 , 45 , 104 , 58 , 119 , 114 , 121 , 238 , 155 , 215 , 239 , 189 , 37 , 236 , 27 , 70 &gt;&gt; , parent_fingerprint : &lt;&lt; 205 , 94 , 166 , 92 &gt;&gt; , type : :private }","ref":"Cryptopunk.html#derive_key/2","title":"Cryptopunk.derive_key/2","type":"function"},{"doc":"Deserialize extended key Examples: iex&gt; Cryptopunk . deserialize_key ( &quot;xprv9s21ZrQH143K3bGcMmWrLU2jguNt5HPuMcuW2ZSTmHWPecUNW1hZgfyGyTLZYEALk46YzbEiPL7v3s2SDxgdbhHF7SiKiMAz4kVx9u5gfr9&quot; ) % Cryptopunk.Key { chain_code : &lt;&lt; 153 , 249 , 145 , 92 , 65 , 77 , 50 , 249 , 120 , 90 , 178 , 30 , 41 , 27 , 73 , 128 , 74 , 201 , 91 , 250 , 143 , 238 , 129 , 247 , 115 , 87 , 161 , 107 , 123 , 63 , 84 , 243 &gt;&gt; , depth : 0 , index : 0 , key : &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; , parent_fingerprint : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , type : :private }","ref":"Cryptopunk.html#deserialize_key/1","title":"Cryptopunk.deserialize_key/1","type":"function"},{"doc":"Generate master private key from seed See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#master-key-generation Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; Cryptopunk . master_key_from_seed ( seed ) % Cryptopunk.Key { chain_code : &lt;&lt; 153 , 249 , 145 , 92 , 65 , 77 , 50 , 249 , 120 , 90 , 178 , 30 , 41 , 27 , 73 , 128 , 74 , 201 , 91 , 250 , 143 , 238 , 129 , 247 , 115 , 87 , 161 , 107 , 123 , 63 , 84 , 243 &gt;&gt; , key : &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; , type : :private , depth : 0 , parent_fingerprint : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , index : 0 }","ref":"Cryptopunk.html#master_key_from_seed/1","title":"Cryptopunk.master_key_from_seed/1","type":"function"},{"doc":"Parse derivation path See https://github.com/bitcoin/bips/blob/master/bip-0044.mediawiki Examples: iex&gt; Cryptopunk . parse_path ( &quot;m / 44&#39; / 0&#39; / 0&#39; / 0 / 0&quot; ) { :ok , % Cryptopunk.Derivation.Path { account : 0 , address_index : 0 , change : 0 , coin_type : 0 , purpose : 44 , type : :private } }","ref":"Cryptopunk.html#parse_path/1","title":"Cryptopunk.parse_path/1","type":"function"},{"doc":"Serialize extended key See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#Serialization_format Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; seed |&gt; Cryptopunk . master_key_from_seed ( ) |&gt; Cryptopunk . serialize_key ( &lt;&lt; 4 , 136 , 173 , 228 &gt;&gt; ) &quot;xprv9s21ZrQH143K3bGcMmWrLU2jguNt5HPuMcuW2ZSTmHWPecUNW1hZgfyGyTLZYEALk46YzbEiPL7v3s2SDxgdbhHF7SiKiMAz4kVx9u5gfr9&quot;","ref":"Cryptopunk.html#serialize_key/2","title":"Cryptopunk.serialize_key/2","type":"function"},{"doc":"Bitcoin address generation logic. All addresses use compressed public keys.","ref":"Cryptopunk.Crypto.Bitcoin.html","title":"Cryptopunk.Crypto.Bitcoin","type":"module"},{"doc":"Generate a bech32 segwit address It accepts three parameters: public or private key. if a private key is provided, it will be converted to public key. network ( :mainnet , :testnet or :regtest ) optional parameters. Currently the only allowed parameter is a witness version ( :version ). Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . bech32_address ( private_key , :mainnet ) &quot;bc1qc89hn5kmwxl804yfqmd97st3trarqr24y2hpqh&quot; iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . bech32_address ( private_key , :mainnet , version : 1 ) &quot;bc1pc89hn5kmwxl804yfqmd97st3trarqr246gsxg7&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Bitcoin . bech32_address ( public_key , :testnet ) &quot;tb1qx3ppj0smkuy3d6g525sh9n2w9k7fm7q3vh5ssm&quot;","ref":"Cryptopunk.Crypto.Bitcoin.html#bech32_address/3","title":"Cryptopunk.Crypto.Bitcoin.bech32_address/3","type":"function"},{"doc":"Generate a legacy (P2PKH) address. It accepts three parameters: public or private key. if a private key is provided, it will be converted to public key. network ( :mainnet or :testnet ) optional keyword params. Currently, the only allowed parameter is :uncompressed key. Passing [uncompressed: true] will generate the address from the uncompressed public key which is not advised. but it may be required for compatibility reasons Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . legacy_address ( private_key , :mainnet ) &quot;1JfhAmwWjbGJ3RW2hjoRdmpKaKXgCjSwEL&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Bitcoin . legacy_address ( public_key , :testnet ) &quot;mkHGce7dctSxHgaWSSbmmrRWsZfzz7MxMk&quot; iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . legacy_address ( private_key , :mainnet , uncompressed : true ) &quot;1AqWUNX6mdaiPay55BqZcAMqNSEJgcgj1D&quot;","ref":"Cryptopunk.Crypto.Bitcoin.html#legacy_address/3","title":"Cryptopunk.Crypto.Bitcoin.legacy_address/3","type":"function"},{"doc":"Generate a 'Pay to Witness Public Key Hash nested in BIP16 Pay to Script Hash' (P2WPKH-P2SH) address It accepts two parameters: public or private key. if a private key is provided, it will be converted to public key. network ( :mainnet or :testnet ) Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . p2sh_p2wpkh_address ( private_key , :mainnet ) &quot;397Y4wveZFbdEo8rTzXSPHWYuamfKs2GWd&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Bitcoin . p2sh_p2wpkh_address ( public_key , :testnet ) &quot;2NFNttcoWjE7WUcByBqpPKkcjg8wzgnU5HE&quot;","ref":"Cryptopunk.Crypto.Bitcoin.html#p2sh_p2wpkh_address/2","title":"Cryptopunk.Crypto.Bitcoin.p2sh_p2wpkh_address/2","type":"function"},{"doc":"Generate a P2SH-P2WPKH (nested segwit) redeem script from the given private or public key Examples iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Bitcoin . p2sh_p2wpkh_redeem_script ( private_key , :binary ) &lt;&lt; 0 , 20 , 193 , 203 , 121 , 210 , 219 , 113 , 190 , 119 , 212 , 137 , 6 , 218 , 95 , 65 , 113 , 88 , 250 , 48 , 13 , 85 &gt;&gt; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Bitcoin . p2sh_p2wpkh_redeem_script ( public_key , :hex ) &quot;00143442193e1bb70916e914552172cd4e2dbc9df811&quot;","ref":"Cryptopunk.Crypto.Bitcoin.html#p2sh_p2wpkh_redeem_script/2","title":"Cryptopunk.Crypto.Bitcoin.p2sh_p2wpkh_redeem_script/2","type":"function"},{"doc":"Validate a bitcoin address Examples iex&gt; Bitcoin . validate ( &quot;bc1qc89hn5kmwxl804yfqmd97st3trarqr24y2hpqh&quot; ) { :ok , %{ network : :mainnet , type : :p2wpkh } } iex&gt; Bitcoin . validate ( &quot;1AqWUNX6mdaiPay55BqZcAMqNSEJgcgj1D&quot; ) { :ok , %{ network : :mainnet , type : :p2pkh } } iex&gt; Bitcoin . validate ( &quot;0AqWUNX6mdaiPay55BqZcAMqNSEJgcgj1D&quot; ) { :error , :invalid_address }","ref":"Cryptopunk.Crypto.Bitcoin.html#validate/1","title":"Cryptopunk.Crypto.Bitcoin.validate/1","type":"function"},{"doc":"Dogecoin address generation logic. It's similar to bitcoin legacy addresses.","ref":"Cryptopunk.Crypto.Dogecoin.html","title":"Cryptopunk.Crypto.Dogecoin","type":"module"},{"doc":"Generate a dogecoin address. It accepts three parameters: public or private key. if a private key is provided, it will be converted to public key. network ( :mainnet or :testnet ) optional keyword params. Currently, the only allowed parameter is :uncompressed key. Passing [uncompressed: true] will generate the address from the uncompressed public key which is not advised. but it may be required for compatibility reasons Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Dogecoin . address ( private_key , :mainnet ) &quot;DNoni2tA31AaaRgdSKnzBXyvTTFyabwPKi&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Dogecoin . address ( public_key , :testnet ) &quot;nYxUariD3FNhvYrgVHGQk6y68aBtLHP87b&quot; iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Dogecoin . address ( private_key , :mainnet , uncompressed : true ) &quot;DEyc1dTk53Uzvb9fomq89vXSFZxc2ZcRbs&quot;","ref":"Cryptopunk.Crypto.Dogecoin.html#address/3","title":"Cryptopunk.Crypto.Dogecoin.address/3","type":"function"},{"doc":"Ethereum address generation logic","ref":"Cryptopunk.Crypto.Ethereum.html","title":"Cryptopunk.Crypto.Ethereum","type":"module"},{"doc":"Generate an ethereum address. EVM compatible chains (for example Binance Smart Chain) may use the same address format. Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Ethereum . address ( private_key ) &quot;0x74510e5055179bcf406d0e7449b47dee9f81e8b7&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Ethereum . address ( public_key ) &quot;0x056db290f8ba3250ca64a45d16284d04bc6f5fbf&quot;","ref":"Cryptopunk.Crypto.Ethereum.html#address/1","title":"Cryptopunk.Crypto.Ethereum.address/1","type":"function"},{"doc":"Encode an address in the EIP-55 mixed-case checksum encoding Examples: iex&gt; Cryptopunk.Crypto.Ethereum . checksum_encode ( &quot;0xea0a6e3c511bbd10f4519ece37dc24887e11b55d&quot; ) { :ok , &quot;0xea0A6E3c511bbD10f4519EcE37Dc24887e11b55d&quot; } iex&gt; Cryptopunk.Crypto.Ethereum . checksum_encode ( &quot;0x52908400098527886e0f7030069857d2e4169ee7&quot; ) { :ok , &quot;0x52908400098527886E0F7030069857D2E4169EE7&quot; } iex&gt; Cryptopunk.Crypto.Ethereum . checksum_encode ( &quot;0x52908400098527886e0f7030069857d2e4169ee&quot; ) { :error , :invalid_address_length }","ref":"Cryptopunk.Crypto.Ethereum.html#checksum_encode/1","title":"Cryptopunk.Crypto.Ethereum.checksum_encode/1","type":"function"},{"doc":"Validate an ethereum address Examples: iex&gt; Cryptopunk.Crypto.Ethereum . valid? ( &quot;0xea0a6e3c511bbd10f4519ece37dc24887e11b55d&quot; ) true iex&gt; Cryptopunk.Crypto.Ethereum . valid? ( &quot;0xea0a6e3c511bbd10f4519ece37dc24887e11b55D&quot; ) false","ref":"Cryptopunk.Crypto.Ethereum.html#valid?/1","title":"Cryptopunk.Crypto.Ethereum.valid?/1","type":"function"},{"doc":"Tron address generation logic.","ref":"Cryptopunk.Crypto.Tron.html","title":"Cryptopunk.Crypto.Tron","type":"module"},{"doc":"Generate a tron address. It accepts two parameters: public or private key. if a private key is provided, it will be converted to public key. network ( :mainnet or :testnet ) Examples: iex&gt; private_key = % Cryptopunk.Key { key : &lt;&lt; 16 , 42 , 130 , 92 , 247 , 244 , 62 , 96 , 24 , 129 , 187 , 141 , 124 , 42 , 176 , 116 , 234 , 171 , 184 , 107 , 3 , 229 , 255 , 72 , 30 , 116 , 79 , 243 , 36 , 142 , 184 , 24 &gt;&gt; , type : :private } iex&gt; Cryptopunk.Crypto.Tron . address ( private_key , :mainnet ) &quot;TLaEVB6foF9nPn4sqscXc5jeH1PVyLwwFK&quot; iex&gt; public_key = % Cryptopunk.Key { key : &lt;&lt; 4 , 57 , 163 , 96 , 19 , 48 , 21 , 151 , 218 , 239 , 65 , 251 , 229 , 147 , 160 , 44 , 197 , 19 , 208 , 181 , 85 , 39 , 236 , 45 , 241 , 5 , 14 , 46 , 143 , 244 , 156 , 133 , 194 , 60 , 190 , 125 , 237 , 14 , 124 , 230 , 165 , 148 , 137 , 107 , 143 , 98 , 136 , 143 , 219 , 197 , 200 , 130 , 19 , 5 , 226 , 234 , 66 , 191 , 1 , 227 , 115 , 0 , 17 , 98 , 129 &gt;&gt; , type : :public } iex&gt; Cryptopunk.Crypto.Tron . address ( public_key , :testnet ) &quot;27PaDLFYbGN9ztPPT3YiTatLQEdEJ2xsfWM&quot;","ref":"Cryptopunk.Crypto.Tron.html#address/2","title":"Cryptopunk.Crypto.Tron.address/2","type":"function"},{"doc":"Implements key derivation logic. See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki","ref":"Cryptopunk.Derivation.html","title":"Cryptopunk.Derivation","type":"module"},{"doc":"","ref":"Cryptopunk.Derivation.html#derive/2","title":"Cryptopunk.Derivation.derive/2","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.html#do_derive/2","title":"Cryptopunk.Derivation.do_derive/2","type":"function"},{"doc":"Utility functions to work with deriviation path See https://github.com/bitcoin/bips/blob/master/bip-0044.mediawiki","ref":"Cryptopunk.Derivation.Path.html","title":"Cryptopunk.Derivation.Path","type":"module"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#is_hardened/1","title":"Cryptopunk.Derivation.Path.is_hardened/1","type":"macro"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#is_normal/1","title":"Cryptopunk.Derivation.Path.is_normal/1","type":"macro"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#new/1","title":"Cryptopunk.Derivation.Path.new/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#parse/1","title":"Cryptopunk.Derivation.Path.parse/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#to_raw_path/1","title":"Cryptopunk.Derivation.Path.to_raw_path/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#two_power_31/0","title":"Cryptopunk.Derivation.Path.two_power_31/0","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#t:raw_path/0","title":"Cryptopunk.Derivation.Path.raw_path/0","type":"type"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#t:t/0","title":"Cryptopunk.Derivation.Path.t/0","type":"type"},{"doc":"Utility functions to work with keys","ref":"Cryptopunk.Key.html","title":"Cryptopunk.Key","type":"module"},{"doc":"","ref":"Cryptopunk.Key.html#deserialize/1","title":"Cryptopunk.Key.deserialize/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#master_key/1","title":"Cryptopunk.Key.master_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new/1","title":"Cryptopunk.Key.new/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_master_private/1","title":"Cryptopunk.Key.new_master_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_master_public/1","title":"Cryptopunk.Key.new_master_public/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_private/1","title":"Cryptopunk.Key.new_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_public/1","title":"Cryptopunk.Key.new_public/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#public_from_private/1","title":"Cryptopunk.Key.public_from_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#serialize/2","title":"Cryptopunk.Key.serialize/2","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#t:t/0","title":"Cryptopunk.Key.t/0","type":"type"},{"doc":"Extended key serialization logic","ref":"Cryptopunk.Key.Serialization.html","title":"Cryptopunk.Key.Serialization","type":"module"},{"doc":"","ref":"Cryptopunk.Key.Serialization.html#decode/1","title":"Cryptopunk.Key.Serialization.decode/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.Serialization.html#encode/2","title":"Cryptopunk.Key.Serialization.encode/2","type":"function"},{"doc":"Wallet import format (WIF) encoding","ref":"Cryptopunk.Key.WIF.html","title":"Cryptopunk.Key.WIF","type":"module"},{"doc":"","ref":"Cryptopunk.Key.WIF.html#decode/2","title":"Cryptopunk.Key.WIF.decode/2","type":"function"},{"doc":"","ref":"Cryptopunk.Key.WIF.html#encode/2","title":"Cryptopunk.Key.WIF.encode/2","type":"function"},{"doc":"Implements seed generation logic. See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki#from-mnemonic-to-seed","ref":"Cryptopunk.Seed.html","title":"Cryptopunk.Seed","type":"module"},{"doc":"","ref":"Cryptopunk.Seed.html#create/2","title":"Cryptopunk.Seed.create/2","type":"function"},{"doc":"Utility functions","ref":"Cryptopunk.Utils.html","title":"Cryptopunk.Utils","type":"module"},{"doc":"","ref":"Cryptopunk.Utils.html#compress_public_key/1","title":"Cryptopunk.Utils.compress_public_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#decompress_public_key/1","title":"Cryptopunk.Utils.decompress_public_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#hash160/1","title":"Cryptopunk.Utils.hash160/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#hmac_sha512/2","title":"Cryptopunk.Utils.hmac_sha512/2","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#ripemd160_hash/1","title":"Cryptopunk.Utils.ripemd160_hash/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#sha256_hash/1","title":"Cryptopunk.Utils.sha256_hash/1","type":"function"}]